# -*- coding: utf-8 -*-
"""setup -- setuptools setup file for pyweek6 entry.

$Author: eykd $
$Rev: 1016 $
$Date: 2008-04-05 16:22:08 -0500 (Sat, 05 Apr 2008) $
"""

__author__ = "$Author: eykd $"
__revision__ = "$Rev: 1016 $"
__version__ = "0.1"
__release__ = '.r'.join((__version__, __revision__[6:-2]))
__date__ = "$Date: 2008-04-05 16:22:08 -0500 (Sat, 05 Apr 2008) $"

import sys

try:
    import setuptools
except ImportError:
    from ez_setup import use_setuptools
    use_setuptools()

from setuptools import setup, find_packages
from setuptools.extension import Extension

APP = ['src/run_game.py']
DATA_FILES = []
APP_OPTIONS = {'argv_emulation': True,
               'optimize': '2',
               }
INSTALL_REQUIRES=['setuptools',
                  'pyglet==1.0',
                  'Rabbyt==0.8.1',
                  'enum==0.4.3',
                  'Cellulose==0.2']

TESTS_REQUIRE=['nose',
               'mocker',
               'figleaf',
               'testoob',
               ]

GUI_SCRIPTS = ['run=projectx.core:main',]

if sys.platform == 'darwin':
    extra_options = dict(
        setup_requires=['py2app', 'setuptools'],
        app=APP,
        options={'py2app':APP_OPTIONS},
        )
elif sys.platform == 'win32':
    extra_options = dict(
        setup_requires=['py2exe'],
        app=APP,
        entry_points={'gui_scripts': GUI_SCRIPTS,},
        )
else:
    extra_options = dict(
        entry_points={'gui_scripts': GUI_SCRIPTS,},
        )

setup(
    name = "projectx",
    version = __version__,
    author = "Binary Defense",

    scripts=APP,

    package_dir = {'': 'src',},
    packages = find_packages('src'),

    install_requires=INSTALL_REQUIRES,
    tests_require=TESTS_REQUIRE,
    test_suite = "nose.collector",

    include_package_data = True,
    zip_safe = False,
    **extra_options
    )
