# -*- coding: utf-8 -*-
#    I, for one, welcome our new robot overloards
#    Copyright (C) 2008 David Eyk, David Thulson, Collin Sanford, David Howery
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License along
#    with this program; if not, write to the Free Software Foundation, Inc.,
#    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
"""core -- core entry points for projectx

$Author: eykd $
$Rev: 964 $
$Date: 2008-04-04 14:35:38 -0500 (Fri, 04 Apr 2008) $
"""

__author__ = "$Author: eykd $"
__revision__ = "$Rev: 964 $"
__version__ = "0.1"
__date__ = "$Date: 2008-04-04 14:35:38 -0500 (Fri, 04 Apr 2008) $"

import pyglet
import rabbyt
import cocos
from cocos.director import director

import sys
from ConfigParser import ConfigParser

import menus

import resources


gentium = resources.getFilePath('fonts/gentium')
bitstream = resources.getFilePath('fonts/bitstream-vera')

pyglet.font.add_directory(gentium)
pyglet.font.add_directory(bitstream)

CAPTION = "I for one WELCOME our new robot overlords."

def LoadOptions(filename):
    def GetOptionDef(CP, SectionName, Name, Default):
        return CP.get(SectionName, Name) if CP.has_option(SectionName, Name) else Default
    SectionName = 'CocosConfig'
    options = {}
    cp = ConfigParser()
    cp.read(filename)

    options['width'] = int(GetOptionDef(cp, SectionName, 'width', 800))
    options['height'] = int(GetOptionDef(cp, SectionName, 'height', 600))
    options['caption'] = GetOptionDef(cp, SectionName, 'caption', CAPTION)
    options['resizable'] = bool(GetOptionDef(cp, SectionName, 'resizable', False))
    options['style'] = GetOptionDef(cp, SectionName, 'style', None)
    options['fullscreen'] = bool(GetOptionDef(cp, SectionName, 'fullscreen', False))
    options['visible'] = bool(GetOptionDef(cp, SectionName, 'visible', True))
    options['vsync'] = bool(GetOptionDef(cp, SectionName, 'vsync', True))
    options['display'] = GetOptionDef(cp, SectionName, 'display', None)
    options['screen'] = GetOptionDef(cp, SectionName, 'screen', None)
    options['config'] = GetOptionDef(cp, SectionName, 'config', None)
    options['context'] = GetOptionDef(cp, SectionName, 'context', None)
    
    return options

def main(config_filename):
    # width=None, height=None, caption=None, resizable=False,
    # style=None, fullscreen=False, visible=True, vsync=True,
    # display=None, screen=None, config=None, context=None

    director.init(**LoadOptions(config_filename))

    scene = menus.MainScene()

    director.run(scene)
    

if __name__ == "__main__":
    config_file = 'config.ini'
    if len(sys.argv) >= 2:
        config_file = sys.argv[1]
    main(config_file)
