# -*- coding: utf-8 -*-
#    I, for one, welcome our new robot overloards
#    Copyright (C) 2008 David Eyk, David Thulson, Collin Sanford, David Howery
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License along
#    with this program; if not, write to the Free Software Foundation, Inc.,
#    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
"""menus -- menus for projectx

$Author: csanford $
$Rev: 827 $
$Date: 2008-03-31 23:11:16 -0500 (Mon, 31 Mar 2008) $
"""

__author__ = "$Author: csanford $"
__revision__ = "$Rev: 827 $"
__date__ = "$Date: 2008-03-31 23:11:16 -0500 (Mon, 31 Mar 2008) $"

from pyglet.window import key

MODIFIERS = frozenset((key.MOD_SHIFT,
                       key.MOD_CTRL,
                       key.MOD_ALT,
                       key.MOD_CAPSLOCK,
                       key.MOD_NUMLOCK,
                       key.MOD_WINDOWS,
                       key.MOD_COMMAND,
                       key.MOD_OPTION,
                       key.MOD_SCROLLLOCK))

SYMBOLS = frozenset((key.NUM_EQUAL,
                     key.NUM_MULTIPLY,
                     key.NUM_ADD,
                     key.NUM_SEPARATOR,
                     key.NUM_SUBTRACT,
                     key.NUM_DECIMAL,
                     key.NUM_DIVIDE,
                     key.SPACE,
                     key.EXCLAMATION,
                     key.DOUBLEQUOTE,
                     key.HASH,
                     key.POUND,
                     key.DOLLAR,
                     key.PERCENT,
                     key.AMPERSAND,
                     key.APOSTROPHE,
                     key.PARENLEFT,
                     key.PARENRIGHT,
                     key.ASTERISK,
                     key.PLUS,
                     key.COMMA,
                     key.MINUS,
                     key.PERIOD,
                     key.SLASH,
                     key.COLON,
                     key.SEMICOLON,
                     key.LESS,
                     key.EQUAL,
                     key.GREATER,
                     key.QUESTION,
                     key.AT,
                     key.BRACKETLEFT,
                     key.BACKSLASH,
                     key.BRACKETRIGHT,
                     key.ASCIICIRCUM,
                     key.UNDERSCORE,
                     key.GRAVE,
                     key.QUOTELEFT,
                     key.BRACELEFT,
                     key.BAR,
                     key.BRACERIGHT,
                     key.ASCIITILDE,
                     key.SPACE,
                     ))
                    
NUMBERS = frozenset((key.NUM_0,
                     key.NUM_1,
                     key.NUM_2,
                     key.NUM_3,
                     key.NUM_4,
                     key.NUM_5,
                     key.NUM_6,
                     key.NUM_7,
                     key.NUM_8,
                     key.NUM_9,))

ALPHA = frozenset((key.A,
                   key.B,
                   key.C,
                   key.D,
                   key.E,
                   key.F,
                   key.G,
                   key.H,
                   key.I,
                   key.J,
                   key.K,
                   key.L,
                   key.M,
                   key.N,
                   key.O,
                   key.P,
                   key.Q,
                   key.R,
                   key.S,
                   key.T,
                   key.U,
                   key.V,
                   key.W,
                   key.X,
                   key.Y,
                   key.Z))

def _buildAlphaNumeric():
    keys = set()
    keys.update(ALPHA)
    keys.update(NUMBERS)
    return keys

ALPHANUMERIC = frozenset(_buildAlphaNumeric())

def _buildCharacters():
    keys = set()
    keys.update(_buildAlphaNumeric())
    keys.update(SYMBOLS)
    return keys

CHARACTERS = frozenset(_buildCharacters())

def _buildEquivalents():
    equivs = {}
    for k in ALPHANUMERIC:
        equivs[k] = unicode(key.symbol_string(k).lower())

    symbols = {key.NUM_EQUAL: u"=",
               key.NUM_MULTIPLY: u"*",
               key.NUM_ADD: u"+",
               key.NUM_SEPARATOR: u",",
               key.NUM_SUBTRACT: u"-",
               key.NUM_DECIMAL: u".",
               key.NUM_DIVIDE: u"/",
               key.SPACE: u" ",
               key.EXCLAMATION: u"!",
               key.DOUBLEQUOTE: u'"',
               key.HASH: u"#",
               key.POUND: u"#",
               key.DOLLAR: u"$",
               key.PERCENT: u"%",
               key.AMPERSAND: u"&",
               key.APOSTROPHE: u"'",
               key.PARENLEFT: u"(",
               key.PARENRIGHT: u")",
               key.ASTERISK: u"*",
               key.PLUS: u"+",
               key.COMMA: u",",
               key.MINUS: u"-",
               key.PERIOD: u".",
               key.SLASH: u"/",
               key.COLON: u":",
               key.SEMICOLON: u";",
               key.LESS: u"<",
               key.EQUAL: u"=",
               key.GREATER: u">",
               key.QUESTION: u"?",
               key.AT: u"@",
               key.BRACKETLEFT: u"[",
               key.BACKSLASH: u"\\",
               key.BRACKETRIGHT: u"]",
               key.ASCIICIRCUM: u"~",
               key.UNDERSCORE: u"_",
               key.GRAVE: u"`",
               key.QUOTELEFT: u'"',
               key.BRACELEFT: u"}",
               key.BAR: u"|",
               key.BRACERIGHT: u"{",
               key.ASCIITILDE: u"`",
               key.SPACE: u" ",}
    equivs.update(symbols)
    return equivs

KEY_MAP = _buildEquivalents()
