# -*- coding: utf-8 -*-
#    I, for one, welcome our new robot overloards
#    Copyright (C) 2008 David Eyk, David Thulson, Collin Sanford, David Howery
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License along
#    with this program; if not, write to the Free Software Foundation, Inc.,
#    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
"""resources -- tools for managing resources.

$Author: csanford $
$Rev: 960 $
$Date: 2008-04-04 13:30:04 -0500 (Fri, 04 Apr 2008) $
"""

__author__ = "$Author: csanford $"
__revision__ = "$Rev: 960 $"
__date__ = "$Date: 2008-04-04 13:30:04 -0500 (Fri, 04 Apr 2008) $"

import os

from pyglet import font
from pyglet import image

__path__ = os.path.dirname(os.path.abspath(__file__))

DATA = os.path.abspath(os.path.join(__path__, '..', '..', 'data'))

def getFilePath(resource_rel):
    """Return the absolute path of the resource relative to the 'data' folder.
    """
    return os.path.abspath(os.path.join(DATA, resource_rel))

_font_cache = {}

def loadFont(name, size, bold=False, italic=False, dpi=None):
    """Load and cache a font w/ the given attributes.
    """
    key = hash((name, size, bold, italic, dpi))

    if _font_cache.has_key(key):
        result = _font_cache[key]
    else:
        result = font.load(name, size, bold, italic, dpi)
        _font_cache[key] = result

    return result

_img_cache = {}

def loadImage(name):
    """Load and cache a file from the data folder.
    """
    key = getFilePath(name)

    if _img_cache.has_key(key):
        result = _img_cache[key]
    else:
        result = image.load(key)
        _font_cache[key] = result

    return result