# -*- coding: utf-8 -*-
#    I, for one, welcome our new robot overloards
#    Copyright (C) 2008 David Eyk, David Thulson, Collin Sanford, David Howery
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License along
#    with this program; if not, write to the Free Software Foundation, Inc.,
#    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

import pyglet

pyglet.options['audio'] = ('openal', 'directsound', 'alsa', 'silent')
from pyglet import media

class Sound(object):
    def __init__(self):
        self._playing = True
        self._sound_sources = {}
        self._player_list = []
    
    def loadSound(self, filename):
        if self._sound_sources.has_key(filename):
            return self._sound_sources[filename]
        else:
            s = media.load(filename, streaming=False)
            self._sound_sources[filename] = s
            return s
    
    def playSound(self, filename, loop=False):
        s = self.loadSound(filename)
        if loop:
            s.eos_action = media.Player.EOS_LOOP
        s.play()
        return s
    
    def update(self):
        if self._playing:
            media.dispatch_events()
    
    def stop(self):
        for p in self._player_list:
            p.pause()
        self._player_list = []
        self._playing = False
    
sound = Sound()
