# -*- coding: utf-8 -*-
#    I, for one, welcome our new robot overloards
#    Copyright (C) 2008 David Eyk, David Thulson, Collin Sanford, David Howery
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License along
#    with this program; if not, write to the Free Software Foundation, Inc.,
#    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
"""vector2d"""

import math

def vec2Dot(a, b):
    return a[0]*b[0] + a[1]*b[1]
    
def vec2LengthSqrd(v):
    return v[0]*v[0] + v[1]*v[1]

def vec2Length(v):
    return math.sqrt(vec2LengthSqrd(v))
    
def vec2Normalize(v):
    l = vec2Length(v)
    if l != 0:
        v[0] /= l
        v[1] /= l
    
def vec2GetNormalized(v):
    l = vec2Length(v)
    if l == 0:
        return [ v[0], v[1] ]
    else:
        return [ v[0] / l, v[1] / l ]

def vec2Sub(a, b):
    return [ a[0] - b[0], a[1] - b[1] ]
