# -*- coding: utf-8 -*-
"""testentity
"""

import unittest
from projectx.camera import Camera
from pyglet import window


class CameraTest(unittest.TestCase):
    """Test Camera class
    """
    def setUp(self):
        self._win = window.Window()
        self._win.dispatch_events()
        pass
    
    def tearDown(self):
        pass
    
    def testCamera(self):
        """Test Camera
        """
        cam = Camera(800, 600)
        plane = cam.beforeDraw()
        try:
            print plane
            self.assertEqual(plane.left, -400)
            self.assertEqual(plane.right, 400)
            self.assertEqual(plane.top, 300)
            self.assertEqual(plane.bottom, -300)
        finally:
            cam.afterDraw()
        
        cam.setPosition(10, 20)
        plane = cam.beforeDraw()
        try:
            self.assertEqual(plane.left, -390)
            self.assertEqual(plane.right, 410)
            self.assertEqual(plane.top, 320)
            self.assertEqual(plane.bottom, -280)
        finally:
            cam.afterDraw()
            
        cam.translate(-10, -20)
        plane = cam.beforeDraw()
        try:
            print plane
            self.assertEqual(plane.left, -400)
            self.assertEqual(plane.right, 400)
            self.assertEqual(plane.top, 300)
            self.assertEqual(plane.bottom, -300)
        finally:
            cam.afterDraw()
        
        #self.assert_(False)
        #self.assert_('b' in self.foo)
        #self.assertEqual(self.foo, 'bar')
        #self.assertNotEqual(math.pi, 3.1415)
        #self.assertAlmostEqual(math.pi, 3.1415, places=3)

        #raisesExc = lambda: len(5)
        #self.assertRaises(TypeError, raisesExc)
            

if __name__ == "__main__":
    # It's nice to be able to just run this test module by itself.
    # I like testoob, because it colorizes.
    import testoob
    testoob.main()
