# -*- coding: utf-8 -*-
"""testexample -- examples of how to write unittests.

$Author: eykd $
$Rev: 804 $
$Date: 2008-03-31 00:25:50 -0500 (Mon, 31 Mar 2008) $
"""

__author__ = "$Author: eykd $"
__revision__ = "$Rev: 804 $"
__date__ = "$Date: 2008-03-31 00:25:50 -0500 (Mon, 31 Mar 2008) $"

import unittest

import time

import math

import projectx

class ExampleTest(unittest.TestCase):
    """Here's an example test case, using the unittest framework.
    """
    def setUp(self):
        """Set up any fixtures you need for every test in the TestCase.

        This gets run before every test.
        """
        self.foo = 'bar'
    
    def tearDown(self):
        """The inverse of setUp. Tear the fixtures down.

        This gets run after every test.
        """
        # This is a silly example.
        del self.foo

    def testSomething(self):
        """An actual test method.  Tests must begin with the word 'test'.

        TestCase gives us lots of built-in assertions:
        """
        self.assert_('b' in self.foo)

        self.assertEqual(self.foo, 'bar')

        self.assertNotEqual(math.pi, 3.1415)

        self.assertAlmostEqual(math.pi, 3.1415, places=3)

        raisesExc = lambda: len(5)

        self.assertRaises(TypeError, raisesExc)

if __name__ == "__main__":
    # It's nice to be able to just run this test module by itself.
    # I like testoob, because it colorizes.
    import testoob
    testoob.main()
